/*
 * YangLivingVideoCaptureWinImpl.cpp
 *
 *  Created on: 2020年8月30日
 *      Author: yang
 */

#include "YangWinVideoCapture.h"
#ifdef _WIN32
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <assert.h>
#include <unistd.h>
#include <wmcodecdsp.h>
#include <initguid.h>
//#include <atlstr.h>
#include <amvideo.h>
#include <wmcodecdsp.h>
#include <initguid.h>
#include <Propsys.h>
#include <uuids.h>

#include "yangutil/sys/YangLog.h"
#define SAFE_RELEASE(x) { if (x) x->Release(); x = NULL; }
//HRESULT WINAPI CopyMediaType(      AM_MEDIA_TYPE *pmtTarget,
 //  const AM_MEDIA_TYPE *pmtSource
//);


#include <combaseapi.h>

HRESULT WINAPI CopyMediaType(AM_MEDIA_TYPE *pmtTarget, const AM_MEDIA_TYPE *pmtSource)
{

    *pmtTarget = *pmtSource;
    if (pmtSource->cbFormat != 0) {
      //  ASSERT(pmtSource->pbFormat != NULL);
        pmtTarget->pbFormat = (PBYTE)CoTaskMemAlloc(pmtSource->cbFormat);
        if (pmtTarget->pbFormat == NULL) {
            pmtTarget->cbFormat = 0;
            return E_OUTOFMEMORY;
        } else {
            CopyMemory((PVOID)pmtTarget->pbFormat, (PVOID)pmtSource->pbFormat,
                       pmtTarget->cbFormat);
        }
    }
    if (pmtTarget->pUnk != NULL) {
        pmtTarget->pUnk->AddRef();
    }

    return S_OK;
}

YangWinVideoCapture::YangWinVideoCapture(YangVideoInfo *pini) {
	m_para = pini;

	m_vhandle = new YangWinVideoCaptureHandle(pini);
	cameraIndex = pini->vIndex;
	m_width = m_para->width;
	m_height = m_para->height;
	m_vd_id = 0;

	m_isloop = 0;
	m_isFirstFrame = 0;
	m_buffer_count = 0;
	m_timestatmp = 0;
	m_pg = NULL;
	m_pb = NULL;
	m_pm = NULL;
	m_videoSrc = NULL;
	m_grabberF=NULL;
	m_grabber=NULL;
	m_event = NULL;
	m_moniker = NULL;
	m_nullRender=NULL;
	m_t_time=0;
	//m_gid=MEDIASUBTYPE_I420;
	//videoRender1 = NULL;

	//vcs=new VideoSampleCapture(&config);

	cameraIndex = 1;
	hasVideo = 1;
	m_preframe = 12;
	//m_fx=conf->fx;
	m_isOpAddMinus = 0;
	memset(&m_yuy2,0,sizeof(m_yuy2));
	memset(&m_i420,0,sizeof(m_i420));
	memset(&m_nv12,0,sizeof(m_nv12));
	memset(&m_yv12,0,sizeof(m_yv12));
	memset(&m_p010,0,sizeof(m_p010));
	memset(&m_p016,0,sizeof(m_p016));
	m_yuy2.yuvType = YangYuy2;
	m_i420.yuvType = YangI420;
	m_nv12.yuvType = YangNv12;
	m_yv12.yuvType = YangYv12;
	m_p010.yuvType=YangP010;
	m_p016.yuvType=YangP016;


}

YangWinVideoCapture::~YangWinVideoCapture() {
	if (m_isloop) {
		stop();
		while (m_isStart) {
			yang_usleep(1000);
		}
	}
	SAFE_RELEASE(m_grabber);
	SAFE_RELEASE(m_grabberF);

	SAFE_RELEASE( m_event);
	SAFE_RELEASE( m_pm);
	SAFE_RELEASE( m_pg);
	SAFE_RELEASE( m_pb);
	SAFE_RELEASE( m_videoSrc);
	delete m_vhandle;
	m_vhandle = NULL;


}

int32_t YangWinVideoCapture::getVideoCaptureState() {
    return m_vhandle->m_isCapture;
}
int32_t YangWinVideoCapture::getLivingVideoCaptureState() {
    return m_vhandle->m_isLivingCaptrue;
}
int32_t YangWinVideoCapture::getFilmVideoCaptureState() {
    return m_vhandle->m_isFilm;
}

void YangWinVideoCapture::setVideoCaptureStart() {
    m_vhandle->m_isCapture = 1;
}
void YangWinVideoCapture::setVideoCaptureStop() {
    m_vhandle->m_isCapture = 0;
}
void YangWinVideoCapture::setLivingVideoCaptureStart() {
    m_vhandle->m_isLivingCaptrue = 1;
}
void YangWinVideoCapture::setLivingVideoCaptureStop() {
    m_vhandle->m_isLivingCaptrue = 0;
}

void YangWinVideoCapture::setFilmVideoCaptureStart() {
    m_vhandle->m_isFilm = 1;
}
void YangWinVideoCapture::setFilmVideoCaptureStop() {
    m_vhandle->m_isFilm = 0;
}

void YangWinVideoCapture::setOutVideoBuffer(YangVideoBuffer *pbuf) {
	m_vhandle->setVideoBuffer(pbuf);
}
void YangWinVideoCapture::setLivingOutVideoBuffer(YangVideoBuffer *pbuf) {
	m_vhandle->setLivingVideoBuffer(pbuf);
}
void YangWinVideoCapture::setFilmOutVideoBuffer(YangVideoBuffer *pbuf) {
	m_vhandle->setFilmVideoBuffer(pbuf);
}
void YangWinVideoCapture::setPreVideoBuffer(YangVideoBuffer *pbuf) {
	m_vhandle->setPreVideoBuffer(pbuf);
}
void YangWinVideoCapture::initstamp() {
	m_vhandle->initstamp();
}
int32_t YangWinVideoCapture::init() {
	CoInitialize(NULL);

	ICreateDevEnum *devEnum = NULL;
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
			CLSCTX_INPROC_SERVER, IID_PPV_ARGS(&devEnum));

	//if (SUCCEEDED(hr)) {
	//	printf("suncess!");
	//} else {
	//	printf("fail");
	//}
	IEnumMoniker *classEnum = NULL;

	ULONG cFetched;

	int32_t cco = 0;
	devEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &classEnum,0);
	while (classEnum->Next(1, &m_moniker, &cFetched) == S_OK) {
		cco++;
		if (cco != cameraIndex)
			continue;
		m_moniker->BindToObject(0, 0, IID_IBaseFilter, (void**) &m_videoSrc);
		m_moniker->Release();
		break;
	}
	classEnum->Release();
	devEnum->Release();

	if (m_videoSrc == NULL)
		return ERROR_SYS_Win_VideoDeveceOpenFailure;

	CoCreateInstance(CLSID_CaptureGraphBuilder2, 0, CLSCTX_INPROC_SERVER,IID_ICaptureGraphBuilder2, (void**) &m_pb);
	CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,IID_IGraphBuilder, (void**) &m_pg);
	m_pb->SetFiltergraph(m_pg);
	m_pg->QueryInterface(IID_IMediaControl, (void**) &m_pm);
	m_pg->AddFilter(m_videoSrc, L"mp4");
	CLSID CLSID_NullRenderer1 = { 0xC1F400A4, 0x3F08, 0x11d3, { 0x9F, 0x0B, 0x00, 0x60, 0x08, 0x03, 0x9E, 0x37 } };
	CLSID CLSID_SampleGrabber1 = { 0xC1F400A0, 0x3F08, 0x11d3, { 0x9F, 0x0B, 0x00, 0x60, 0x08, 0x03, 0x9E, 0x37 } };
	 hr=CoCreateInstance(CLSID_SampleGrabber1, NULL, CLSCTX_INPROC_SERVER,IID_PPV_ARGS(&m_grabberF));
		hr = m_pg->AddFilter(m_grabberF, L"Sample Grabber");

		hr = m_grabberF->QueryInterface(IID_ISampleGrabber,(void **)&m_grabber);
		hr=m_pg->QueryInterface(IID_IMediaEventEx,(void **)&m_event);

		m_nullRender=NULL;
		hr=CoCreateInstance(CLSID_NullRenderer1, NULL, CLSCTX_INPROC, IID_IBaseFilter,(void **)&m_nullRender);

		setRevolutionPara();

			//m_yuy2, m_i420 , m_nv12, m_yv12
			if(m_i420.state>1||m_nv12.state>1||m_yv12.state>1||m_yuy2.state>1){
					if(m_i420.state>1) {
						m_para->videoCaptureFormat=YangI420;
					}else if(m_nv12.state>1){
						m_para->videoCaptureFormat=YangNv12;
					}else if(m_yv12.state>1){
						m_para->videoCaptureFormat=YangYv12;
					}else if(m_yuy2.state>1){
						m_para->videoCaptureFormat=YangYuy2;
					}
					#if Yang10bit
					if(m_para->videoCaptureFormat==YangP010) format=V4L2_PIX_FMT_P010;
					if(m_para->videoCaptureFormat==YangP016) format=V4L2_PIX_FMT_P016;
					#endif

				}else if(m_i420.state||m_nv12.state||m_yv12.state||m_yuy2.state){
					if(m_i420.state) {
						setWH(&m_i420);
					}else if(m_nv12.state){
						setWH(&m_nv12);
					}else if(m_yv12.state){
						setWH(&m_yv12);
					}else if(m_yuy2.state){
						setWH(&m_yuy2);
					}
					//setReselution(format);
				}else{
					return ERROR_SYS_Win_NoVideoDriver;
				}

			setRevolution();
           //  if(1) return 0;
			if(m_vhandle) m_vhandle->setCaptureFormat(m_para->videoCaptureFormat);
			return Yang_Ok;
}

IPin* YangWinVideoCapture::FindPin(IBaseFilter *pFilter, PIN_DIRECTION dir) {
	IEnumPins *pEnumPins;
	IPin *pOutpin;
	PIN_DIRECTION pDir;
	pFilter->EnumPins(&pEnumPins);
	while (pEnumPins->Next(1, &pOutpin, NULL) == S_OK) {
		pOutpin->QueryDirection(&pDir);

		if (pDir == dir) {
			pEnumPins->Release();
			pEnumPins = NULL;
			return pOutpin;
		}
	}
	return 0;
}
REFGUID YangWinVideoCapture::getUID(){
	YangYuvType format=(YangYuvType)m_para->videoCaptureFormat;
	  if(format==YangYuy2) return MEDIASUBTYPE_YUY2;
	  if(format==YangI420) return MEDIASUBTYPE_I420;
	  if(format==YangNv12) return MEDIASUBTYPE_NV12;
	  if(format==YangYv12) return MEDIASUBTYPE_YV12;
	return MEDIASUBTYPE_I420;

}
void YangWinVideoCapture::setRevolutionPara() {
	IAMStreamConfig *config1 = 0;
	m_pb->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, m_videoSrc,
			IID_IAMStreamConfig, (void**) &config1);
	int32_t iCount = 0, iSize = 0;
	HRESULT hr = config1->GetNumberOfCapabilities(&iCount, &iSize);



	if (iSize == sizeof(VIDEO_STREAM_CONFIG_CAPS)) {
		for (int32_t iFormat = 0; iFormat < iCount; iFormat++) {
			VIDEO_STREAM_CONFIG_CAPS scc;
			AM_MEDIA_TYPE *pmtConfig;

			hr = config1->GetStreamCaps(iFormat, &pmtConfig, (BYTE*) &scc);
			VIDEOINFOHEADER* pvih1=(VIDEOINFOHEADER*)pmtConfig->pbFormat;

			if(IsEqualGUID(pmtConfig->subtype, MEDIASUBTYPE_I420)){
				if(!m_i420.state) m_i420.state=1;
				if(pvih1->bmiHeader.biWidth==m_para->width&&pvih1->bmiHeader.biHeight==m_para->height) m_i420.state=2;
				m_i420.width=pvih1->bmiHeader.biWidth;
				m_i420.height=pvih1->bmiHeader.biHeight;
			}else if(IsEqualGUID(pmtConfig->subtype, MEDIASUBTYPE_NV12)){
				if(!m_nv12.state) m_nv12.state=1;
				if(pvih1->bmiHeader.biWidth==m_para->width&&pvih1->bmiHeader.biHeight==m_para->height) m_nv12.state=2;
				m_nv12.width=pvih1->bmiHeader.biWidth;
				m_nv12.height=pvih1->bmiHeader.biHeight;
			}else if(IsEqualGUID(pmtConfig->subtype, MEDIASUBTYPE_YV12)){
				if(!m_yv12.state) m_yv12.state=1;
				if(pvih1->bmiHeader.biWidth==m_para->width&&pvih1->bmiHeader.biHeight==m_para->height) m_yv12.state=2;
				m_yv12.width=pvih1->bmiHeader.biWidth;
				m_yv12.height=pvih1->bmiHeader.biHeight;
			}else if(IsEqualGUID(pmtConfig->subtype, MEDIASUBTYPE_YUY2)){
				if(!m_yuy2.state) m_yuy2.state=1;
				if(pvih1->bmiHeader.biWidth==m_para->width&&pvih1->bmiHeader.biHeight==m_para->height) m_yuy2.state=2;
				m_yuy2.width=pvih1->bmiHeader.biWidth;
				m_yuy2.height=pvih1->bmiHeader.biHeight;
			}
			pvih1=NULL;
		}
	}
}
void YangWinVideoCapture::setRevolution() {
	IAMStreamConfig *config1 = 0;
	//int32_t frame=333667;
	/**int32_t frame=333333;
	 switch(m_para->frame){
	 case 25:frame=400000;break;
	 case 20:frame=500000;break;
	 case 30:frame=333333;break;
	 //case 30:frame=333667;break;
	 }**/
	m_pb->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, m_videoSrc,IID_IAMStreamConfig, (void**) &config1);
	int32_t iCount = 0, iSize = 0;
	HRESULT hr = config1->GetNumberOfCapabilities(&iCount, &iSize);
//printf("***********start setRevolution*******************\n");
// Check the size to make sure we pass in the correct structure.
	YangYuvType format=(YangYuvType)m_para->videoCaptureFormat;

	if (iSize == sizeof(VIDEO_STREAM_CONFIG_CAPS)) {
		// Use the video capabilities structure.

		for (int32_t iFormat = 0; iFormat < iCount; iFormat++) {
			VIDEO_STREAM_CONFIG_CAPS scc;
			AM_MEDIA_TYPE *pmtConfig;
			AM_MEDIA_TYPE amt;
			hr = config1->GetStreamCaps(iFormat, &pmtConfig, (BYTE*) &scc);
			VIDEOINFOHEADER* pvih1=(VIDEOINFOHEADER*)pmtConfig->pbFormat;

				if (IsEqualGUID(pmtConfig->subtype,getUID())&&pvih1->bmiHeader.biWidth==m_para->width&&pvih1->bmiHeader.biHeight==m_para->height) {

						CopyMediaType(&amt, pmtConfig);
						VIDEOINFOHEADER *pvih = (VIDEOINFOHEADER*) amt.pbFormat;
						BITMAPINFOHEADER bmi = pvih->bmiHeader;
						pvih->bmiHeader.biWidth = m_para->width;
						pvih->bmiHeader.biHeight = m_para->height;
						pvih->bmiHeader.biBitCount = format==YangYuy2?16:12;//config.Video_Bit_Count;
						pvih->bmiHeader.biSizeImage = pvih->bmiHeader.biWidth
								* pvih->bmiHeader.biHeight
								* pvih->bmiHeader.biBitCount / 8;
						//pvih->AvgTimePerFrame = (REFERENCE_TIME) frame;
						//pvih->AvgTimePerFrame=frame;
						yang_info("\nset %d Camera Revolution Sucess!width=%d,height=%d..\n",cameraIndex,m_para->width,m_para->height);
						config1->SetFormat(&amt);
						pvih = NULL;
						//break;
						return;


				}
				pvih1=NULL;
			}
			//
		}
	//}
	//printf("\nCamera %d Error Error!.yuy2 or Nv12 not exists............\n",cameraIndex);
	//ExitProcess(0);

}


long YangWinVideoCapture::m_difftime(struct timeval *p_start,
		struct timeval *p_end) {
	return (p_end->tv_sec - p_start->tv_sec) * 1000000
			+ (p_end->tv_usec - p_start->tv_usec);
}


void YangWinVideoCapture::stopLoop() {
	m_isloop = 0;
	if(m_pm!=NULL) m_pm->Stop();
}
void YangWinVideoCapture::setWH(YangVideoCaptureType *pct){
	m_width=pct->width;
	m_height=pct->height;
	m_para->width=pct->width;
	m_para->height=pct->height;
	m_para->videoCaptureFormat=pct->yuvType;
}
void YangWinVideoCapture::startLoop() {
	if (m_videoSrc == NULL)
		return;

	IPin *pVideoOut = FindPin(m_videoSrc, PINDIR_OUTPUT);
	IPin *pGrabin = FindPin(m_grabberF, PINDIR_INPUT);
	IPin *pGrabout = FindPin(m_grabberF, PINDIR_OUTPUT);
	IPin *pNullIn = FindPin(m_nullRender, PINDIR_INPUT);
	HRESULT hr = m_pg->Connect(pVideoOut, pGrabin);
	hr = m_pg->Connect(pGrabout, pNullIn);
	SAFE_RELEASE(pVideoOut);
	SAFE_RELEASE(pGrabin);
	SAFE_RELEASE(pGrabout);
	SAFE_RELEASE(pNullIn);
	hr = m_grabber->SetBufferSamples(TRUE);
	//pGrabber->se
	hr = m_grabber->SetOneShot(FALSE);
	m_grabber->SetCallback(m_vhandle, 1);
	m_pm->Run();
	//m_handle->m_start_time = ::GetTickCount();
	long eventCode;
	//printf("pevent===%s\n",pEvent==NULL?"NULL":"not null");
	//crf->isStart = 1;

//	if (m_isOpAddMinus) {
//		vcs->isAddMinus = 1;
//		vcs->adjustTime(m_t_time);
//	}
	m_event->WaitForCompletion(INFINITE, &eventCode);
}
#endif
